#include <cstdio>
using namespace std;

int add(int x, int y) {
  // sadly, the C++ standard does NOT define overflow for signed integers
  // the way one would expect: it is not guaranteed that (2^31 - 1) + 1 gives -2^31
  // hence we use 64-bit integers to guarantee this behavior of our code

  long long sum = (long long) x + (long long) y;
  long long MAX_INT = (1LL << 31) - 1;
  long long MIN_INT = - (1LL << 31);
  while (sum > MAX_INT) sum -= 1LL << 32;
  while (sum < MIN_INT) sum += 1LL << 32;
  return (int) sum;
}

bool magic(int x) {
  int foo = 0;
  while (x > 1)
    for (int y=2; ; y=add(y,1)) {
      if (y==x) return foo<=0;
      if (magic(y) && x%y==0) { x/=y; foo=add(foo,1); break; }
    }
  return true;
}

int main() {
  int where = 2147483647;
  int step = 2;
  int best = where;
  while (step) {
    where = add(where,step);
    printf("%d\n",where);
    if (where < best) { best=where; printf("*\n"); }
    if (!magic(where)) break;
  }
}
